"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var deepMap = function deepMap(obj, fn) {
  var deepMapper = function deepMapper(val) {
    return isObject(val) ? deepMap(val, fn) : fn(val);
  };

  if (Array.isArray(obj)) {
    return obj.map(deepMapper);
  }

  if (isObject(obj)) {
    return mapObject(obj, deepMapper);
  }

  return obj;
};

var mapObject = function mapObject(obj, fn) {
  return Object.keys(obj).reduce(function (res, key) {
    res[key] = fn(obj[key]);
    return res;
  }, {});
};

var isObject = function isObject(myVar) {
  return myVar && _typeof(myVar) === 'object';
};

var _default = deepMap;
exports["default"] = _default;