"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mvs = exports.ms = exports.vs = exports.s = exports.moderateVerticalScale = exports.moderateScale = exports.verticalScale = exports.scale = exports.setBaseHeight = exports.setBaseWidth = void 0;

var _reactNative = require("react-native");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var _Dimensions$get = _reactNative.Dimensions.get('window'),
    width = _Dimensions$get.width,
    height = _Dimensions$get.height;

var _ref = width < height ? [width, height] : [height, width],
    _ref2 = _slicedToArray(_ref, 2),
    shortDimension = _ref2[0],
    longDimension = _ref2[1]; //Default guideline sizes are based on standard ~5" screen mobile device


var guidelineBaseWidth = 350;
var guidelineBaseHeight = 680;

var setBaseWidth = function setBaseWidth(width) {
  guidelineBaseWidth = width;
};

exports.setBaseWidth = setBaseWidth;

var setBaseHeight = function setBaseHeight(height) {
  guidelineBaseHeight = height;
};

exports.setBaseHeight = setBaseHeight;

var scale = function scale(size) {
  return shortDimension / guidelineBaseWidth * size;
};

exports.scale = scale;

var verticalScale = function verticalScale(size) {
  return longDimension / guidelineBaseHeight * size;
};

exports.verticalScale = verticalScale;

var moderateScale = function moderateScale(size) {
  var factor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0.5;
  return size + (scale(size) - size) * factor;
};

exports.moderateScale = moderateScale;

var moderateVerticalScale = function moderateVerticalScale(size) {
  var factor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0.5;
  return size + (verticalScale(size) - size) * factor;
};

exports.moderateVerticalScale = moderateVerticalScale;
var s = scale;
exports.s = s;
var vs = verticalScale;
exports.vs = vs;
var ms = moderateScale;
exports.ms = ms;
var mvs = moderateVerticalScale;
exports.mvs = mvs;